package kz.project.printedFormsService.data.dto;

import lombok.Builder;
import lombok.Data;
import lombok.Getter;
import lombok.Setter;
import lombok.experimental.Accessors;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.time.LocalDate;
import java.util.List;

@Getter
@Setter
@Accessors(chain = true)
public class DocumentByDateDto extends ResultDto {
    public DocumentByDateDto(String status, String message) {
        super(status, message);
    }

    @Nullable
    private DocumentsData data;

    @Data
    @Builder
    public static class DocumentsData {
        @NotNull
        private LocalDate startDate;

        @NotNull
        private LocalDate endDate;

        @NotNull
        private List<DocumentCount> documentCounts;
    }

    @Data
    @Builder
    public static class DocumentCount {
        @NotNull
        private LocalDate date;

        @NotNull
        private Integer count;
    }
}
