package kz.project.printedFormsService.data.dto;

import lombok.Builder;
import lombok.Data;
import lombok.Getter;
import lombok.Setter;
import lombok.experimental.Accessors;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.time.LocalDate;
import java.util.List;

@Getter
@Setter
@Accessors(chain = true)
public class DocumentByTemplateDto extends ResultDto {
    public DocumentByTemplateDto(String status, String message) {
        super(status, message);
    }

    @Nullable
    private DocumentsData data;

    @Data
    @Builder
    public static class DocumentsData {
        @NotNull
        private LocalDate startDate;

        @NotNull
        private LocalDate endDate;

        @NotNull
        private List<TemplateCount> templateCounts;
    }

    @Data
    @Builder
    public static class TemplateCount {
        @NotNull
        private String templateId;

        @Nullable
        private String templateName;

        @NotNull
        private Integer totalCount;
    }
}
