package kz.project.printedFormsService.data.entity;

import jakarta.persistence.*;
import lombok.Getter;
import lombok.Setter;
import lombok.experimental.Accessors;
import org.hibernate.annotations.CreationTimestamp;
import org.hibernate.annotations.SourceType;

import java.time.LocalDateTime;

@Entity
@Table(name = "document", schema = "template_schema")
@Getter
@Setter
@Accessors(chain = true)
public class DocumentEntity {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @ManyToOne
    @JoinColumn(name = "template_id", referencedColumnName = "template_id",insertable = false,updatable = false)
    private TemplateEntity template;

    @CreationTimestamp
    private LocalDateTime createdAt;

    private String project;
}
