package kz.project.printedFormsService.data.entity;

import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

@Entity
@Table(name = "file_info", schema = "template_schema")
@Data
@AllArgsConstructor
@NoArgsConstructor
@Builder
public class TemplateFileInfoEntity {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    private String name;
    private Boolean isHeader;
    private String path;
    private Integer hash;
    private byte[] data;

    @Override
    public boolean equals(Object o){
        if (this == o) return true;

        if (o == null || !(o instanceof TemplateFileInfoEntity)) return false;

        TemplateFileInfoEntity other = (TemplateFileInfoEntity) o;

        boolean isNameEqual = this.name == other.getName() || (this.name != null && this.name.equals(other.getName()));
        boolean isHeaderEqual = this.isHeader == other.getIsHeader() || (this.isHeader != null && this.isHeader.equals(other.getIsHeader()));
        boolean isPathEqual = this.path == other.getPath() || (this.path != null && this.path.equals(other.getPath()));
        boolean isHashEqual = this.hash == other.getHash() || (this.hash != null && this.hash.equals(other.getHash()));
        boolean isDataEqual = this.data == other.getData() || (this.data != null && this.data.equals(other.getData()));

        return isNameEqual && isHeaderEqual && isPathEqual && isHashEqual && isDataEqual;
    }

    @Override
    public int hashCode(){
        int hashResult = 17;

        if (name != null) hashResult = 31 * hashResult * name.hashCode();
        if (isHeader != null) hashResult = 31 * hashResult * isHeader.hashCode();
        if (path != null) hashResult = 31 * hashResult * path.hashCode();
        if (hash != null) hashResult = 31 * hashResult * hash.hashCode();
        if (data != null) hashResult = 31 * hashResult * data.hashCode();

        return hashResult;
    }
}
