package kz.project.printedFormsService.service.impl;

import kz.project.printedFormsService.controller.TemplateController;
import kz.project.printedFormsService.data.dto.DTemplateTypeDto;
import kz.project.printedFormsService.data.entity.dict.DTemplateType;
import kz.project.printedFormsService.data.repository.DTemplateTypeRepository;
import kz.project.printedFormsService.logging.ProcessLogger;
import kz.project.printedFormsService.service.DTemplateTypeService;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class DTemplateTypeServiceImpl implements DTemplateTypeService {
    private final DTemplateTypeRepository repository;
    private ProcessLogger processLogger;

    public DTemplateTypeServiceImpl(DTemplateTypeRepository repository, ProcessLogger processLogger) {
        this.repository = repository;
        this.processLogger = processLogger;
    }

    public List<DTemplateTypeDto> getAllTemplateType(){
        processLogger.start(TemplateController.class, new Throwable().getStackTrace()[0].getMethodName(), "Получение типов шаблонов");
        List<DTemplateType> all = repository.findAll();
        processLogger.finish(TemplateController.class, new Throwable().getStackTrace()[0].getMethodName(), "Получение типов шаблонов");
        return DTemplateTypeDto.toDtoList(all);
    }
}
